## mingw-w64-opencascade-7.8.1-2.src.tar.zst

=== src/TKVCAF/CMakeLists.txt ===
project(TKVCAF)

OCCT_INCLUDE_CMAKE_FILE (adm/cmake/occt_toolkit)
