=== src/TKXSBase/CMakeLists.txt ===
project(TKXSBase)

OCCT_INCLUDE_CMAKE_FILE (adm/cmake/occt_toolkit)
