=== src/TKXSDRAWPLY/CMakeLists.txt ===
project(TKXSDRAWPLY)

OCCT_INCLUDE_CMAKE_FILE (adm/cmake/occt_toolkit)
