=== src/TKXml/CMakeLists.txt ===
project(TKXml)

OCCT_INCLUDE_CMAKE_FILE (adm/cmake/occt_toolkit)
